using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace SampleProjectCSharp
{
	/// <summary>
	/// Summary description for product2.
	/// </summary>
	public class product2 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnCancel;
		protected System.Web.UI.WebControls.Button btnSave;
		protected System.Web.UI.WebControls.Label Label9;
		protected System.Web.UI.WebControls.TextBox txtReOrderLevel;
		protected System.Web.UI.WebControls.Label Label8;
		protected System.Web.UI.WebControls.TextBox txtOnOrder;
		protected System.Web.UI.WebControls.Label Label7;
		protected System.Web.UI.WebControls.TextBox txtOnHand;
		protected System.Web.UI.WebControls.Label Label6;
		protected System.Web.UI.WebControls.TextBox txtUnitPrice;
		protected System.Web.UI.WebControls.Label Label5;
		protected System.Web.UI.WebControls.TextBox txtQtyPerUnit;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.TextBox txtCategoryID;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.TextBox txtSupplierID;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.TextBox txtProductName;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label lblHeader;
		protected System.Web.UI.HtmlControls.HtmlInputCheckBox chkDiscontinued;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here

			btnCancel.Attributes["onclick"] = "javascript:window.close();";

			if (!Page.IsPostBack)
			{

				if(Request.Params["product"] != null)
				{
					this.lblHeader.Text = "Product - EDIT";
					Retrieve();
				}

				else
				{
					this.lblHeader.Text = "Product - NEW";
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Retrieve()
		{
			Product prod = new Product(); // Creates a new object - Created by Class Generator

			prod.ProductID = Convert.ToInt32(Request.Params["product"]);
			prod.Retrieve(); // Accessing the Function that was generated by the Class Generator

			if(prod.Found)
			{
		
				this.txtProductName.Text     = prod.ProductName;
				this.txtSupplierID.Text      = prod.SupplierID.ToString();
				this.txtCategoryID.Text      = prod.CategoryID.ToString();
				this.txtQtyPerUnit.Text      = prod.QuantityPerUnit;
				this.txtUnitPrice.Text       = prod.UnitPrice.ToString();
				this.txtOnHand.Text          = prod.UnitsInStock.ToString();
				this.txtOnOrder.Text         = prod.UnitsOnOrder.ToString();
				this.txtReOrderLevel.Text    = prod.ReorderLevel.ToString();
				this.chkDiscontinued.Checked = prod.Discontinued;
							
			}
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			
			Product prod = new Product(); // Creates a new object - Created by Class Generator
			bool result;

			prod.ProductName     = this.txtProductName.Text;
			prod.SupplierID      = Convert.ToInt32(this.txtSupplierID.Text);
			prod.CategoryID      = Convert.ToInt32(this.txtCategoryID.Text);
			prod.QuantityPerUnit = this.txtQtyPerUnit.Text;
            prod.UnitPrice       = (decimal) Conversion.Val(this.txtUnitPrice.Text);
            prod.ReorderLevel    = (short) Conversion.Val(this.txtReOrderLevel.Text);
			prod.Discontinued    = this.chkDiscontinued.Checked;

			if (Request.Params["product"] != null)
			{
				prod.ProductID = Convert.ToInt32(Request.Params["product"]);
				result = prod.Update(); // Accessing the Function that was generated by the Class Generator
			}

			else
			{
				result = prod.Save(); // Accessing the Function that was generated by the Class Generator
			}
            
			if (result)
			{
				Response.Write("<script>window.opener.document.forms(0).hiddenRefresh.value = '1';</script>");
				Response.Write("<script>window.opener.document.forms(0).submit(); window.close();</script>");
			}
		}
	}
}
